Status: Closed Start date:  
Assignee: Go MAEDA % Done: 0%

Category: Project settings Estimated time: 0.00 hour

Target version: 5.0.0   

Resolution: Fixed Affected version:  

Description

If you save system activities without editing them in the project settings, some activities will be created as project-specific activities.

 reproduce.gif 

Associated revisions

Revision 21319 - 2021-12-21 07:42 - Go MAEDA

Saving time tracking activities without any change may turn a system activity into a project activity (#36318).

Patch by Yuichi HARADA.

History

#1 - 2021-12-15 03:12 - Yuichi HARADA

- File 36318.patch added

The following patch will solve the issue. I have attached a patch.

diff --git a/app/models/enumeration.rb b/app/models/enumeration.rb

index 5f0e023ed9..534d8239e1 100644

--- a/app/models/enumeration.rb

+++ b/app/models/enumeration.rb

@@ -117,7 +117,7 @@ class Enumeration < ActiveRecord::Base

   # Does the +new+ Hash have the same custom values as the previous Enumeration?

   def self.same_custom_values?(new, previous)

     previous.custom_field_values.each do |custom_value|

-      if custom_value.value != new["custom_field_values"][custom_value.custom_field_id.to_s]

+      if custom_value.to_s != new["custom_field_values"][custom_value.custom_field_id.to_s].to_s

         return false

       end

     end

#2 - 2021-12-15 04:11 - Go MAEDA

Could you explain the conditions that cause this issue?

#3 - 2021-12-15 05:49 - Go MAEDA

Go MAEDA wrote:

Could you explain the conditions that cause this issue?

 I understand the condition.

The issue occurs when the value of a custom field of the activity is nil, and the new value for the custom field in the "new" hash is unset (the value will

be a blank string). As a result, the conditional expression of the if statement will be false and a project-specific activity will be wrongly created.

#4 - 2021-12-15 06:30 - Go MAEDA

- Status changed from New to Confirmed

- Target version set to 4.1.6

Setting the target version to 4.1.6.
#5 - 2021-12-15 07:56 - Yuichi HARADA

- File 36318-v2.patch added

I forgot to fix test/unit/time_entry_activity_test.rb. Reattached the patch.

#6 - 2021-12-21 06:47 - Go MAEDA

- Subject changed from Some system activities are created as project-specific activities when there are custom fields for activities to Saving time

tracking activities without any change may turn a system activity to a project activity

#7 - 2021-12-21 07:43 - Go MAEDA

- Subject changed from Saving time tracking activities without any change may turn a system activity to a project activity to Saving time tracking

activities without any change may turn a system activity into a project activity

- Status changed from Confirmed to Closed

- Assignee set to Go MAEDA

- Target version changed from 4.1.6 to 5.0.0

- Resolution set to Fixed

Committed the fix. Thank you.
